// extern struct FsMapperFlash fsMapFlash;
// extern struct FsMapperTiny fsMapTiny;
// s_int16 FsMlcMapRead1(struct FsMapper *map, u_int32 sector,
// 		     u_int16 logicalBlocks, u_int16 *data) {

#define FSMAPTINY_ROOT 12 //field root, offset 12
#define FSMAPTINY_FIRSTBLOCK 15 // field firstBlock, offset 15
#define FSMAPTINY_LASTBLOCK  17 // field lastBlock, offset 17
#define FSMAPTINY_LOGTOPHYS  19 // field logToPhys, offset 19
#define FSMAPTINY_META       21 // field meta, offset 21


	.import _ph,_fsMapTiny,divide32unsigned

#if 0
	.sect code,FsMlcMapRead1	// 107 words -> 82 words
	.export _FsMlcMapRead1
_FsMlcMapRead1:	// PROLOGUE
	ldx (I6)+1,NULL
	stx C1,(I6)+1 ; sty I1,(I6)
	stx LR0,(I6)+1 ; sty I5,(I6)
	stx I6,(I6) ; sty I4,(I6)
	ldx (I6)+1,I4
	stx A1,(I6)+1 ; sty B0,(I6)
	stx B1,(I6) ; sty C0,(I6)

// indirect field ph->eraseBlockSize, offset 2 (struct at page 1)
// indirect field ph->Read, offset 6 (struct at page 1)

//     if (sector < fsMapTiny.firstBlock || sector > fsMapTiny.lastBlock)

	ldc _fsMapTiny+FSMAPTINY_FIRSTBLOCK,I0
	ldy (I4)-5,NULL ; ldx (I0)+1,A0
	ldx (I4)+1,B0	// B=sector
	ldx (I4)-3,B1
	ldx (I0)+(FSMAPTINY_LASTBLOCK-FSMAPTINY_FIRSTBLOCK-1),A1
	sub B,A,A	; ldx (I0)+1,C0
	ldc _ph,I1
	jcc L3	// <
	ldx (I0)-1,C1

	sub C,B,A
	ldc _fsMapTiny+FSMAPTINY_LOGTOPHYS,I0
	jcs L2	// >=
	nop

L3:

//  {
// 	register __c0 u_int16 eB = sector / ph->eraseBlockSize;
// 	ph->Read(ph, fsMapTiny.root + (eB >> 8), 1, data, &fsMapTiny.meta);

	ldx (I1),I5
	ldx (I5)+2,NULL	; ldy (I6)+1,NULL	//+1 for ->Read() parameters
	call divide32unsigned			//destroys B
	and A1,NULL,A1	; ldx (I5),A0

	//ldc _ph,I1
	ldc _fsMapTiny+FSMAPTINY_ROOT,I0
	ldc _fsMapTiny+FSMAPTINY_META,C1
	add a0,null,c0	; stx C1,(I6)+1
	ldc 256,A1
	muluu A1,C0	; ldx (I4),A0	// data
	sub NULL,ONES,A0	; stx A0,(I6)+1
	add NULL,P,A	; stx A0,(I6)+1
	add A1,null,B0	; ldx (I0)+1,A0
	and D1,NULL,B1	; ldx (I0)-1,A1
	add A,B,A	; ldx (I1),I5
	stx A0,(I6)+1
	stx A1,(I6)+1
	stx I5,(I6)	; ldy (I5)+6,NULL
	ldx (I5),LR0
	jr
	ldc L4,LR0

L4:

// 	fsMapTiny.logToPhys = (u_int32)data[eB & 255] * ph->eraseBlockSize;
// 	fsMapTiny.firstBlock = sector & ~(u_int32)(ph->eraseBlockSize-1);
// 	fsMapTiny.lastBlock = fsMapTiny.firstBlock + ph->eraseBlockSize-1;

	ldx (I1),I7	; ldy (I0)+(FSMAPTINY_LOGTOPHYS-FSMAPTINY_ROOT),NULL
	ldx (I4)+2,A0	; ldy (I7)+2,NULL	// data
	ldc 255,C1
	and C0,C1,C1	; ldx (I4)+1,B0	// B=sector, reread
	add A0,C1,C1	; ldx (I7),A0
	mv C1,I5
	ldx (I5),A1
	muluu A1,A0	; ldx (I4)-3,B1
	add NULL,P,C	; ldx (I7),A0
	and A1,NULL,A1	; stx C0,(I0)+1
	add A0,ONES,A0	; stx C1,(I0)+(FSMAPTINY_FIRSTBLOCK-FSMAPTINY_LOGTOPHYS-1)
	xor A,ONES,A
	and A,B,A	; ldx (I7),C0
	and C1,NULL,C1	; stx A0,(I0)+1
	add A,C,A	; stx A1,(I0)+(FSMAPTINY_LASTBLOCK-FSMAPTINY_FIRSTBLOCK-1)
	add A,ONES,A
	stx A0,(I0)+1	; ldy (I6)-6,NULL
	stx A1,(I0)+(FSMAPTINY_LOGTOPHYS-FSMAPTINY_LASTBLOCK-1)

//     }

	//ldc _fsMapTiny+FSMAPTINY_LOGTOPHYS,I0
L2:
//     {
// 	register __c u_int32 phy =
// 	    fsMapTiny.logToPhys + sector - fsMapTiny.firstBlock;
// 	ph->Read(ph, phy, 1, data, &fsMapTiny.meta);

	//ldc _ph,I1
	ldx (I0)+1,C0
	ldx (I0)+(FSMAPTINY_FIRSTBLOCK-FSMAPTINY_LOGTOPHYS-1),C1 ; ldy (I6)+1,NULL
	add C,B,C ; ldx (I0)+1,B0
	ldc _fsMapTiny+FSMAPTINY_META,A0
	ldx (I0)-1,B1
	sub C,B,C ; stx A0,(I6)+1
	ldx (I4)+7,A0	// data
	sub NULL,ONES,A0	; stx A0,(I6)+1
	stx A0,(I6)+1
	stx C0,(I6)+1
	stx C1,(I6)+1
	ldx (I1),I5
	stx I5,(I6) ; ldy (I5)+6,NULL
	ldx (I5),LR0
	jr
	ldc L5,LR0
L5:
//     }
//     return 1;

	sub NULL,ONES,A0	; ldx (I6)-6,NULL
	ldx (I6)-1,B1 ; ldy (I6),C0
	ldx (I6)-1,A1 ; ldy (I6),B0
	ldx (I4),I6 ; ldy (I4),I4	// Read Sp and Fp
	ldx (I6)-1,NULL
	ldx (I6)-1,LR0 ; ldy (I6),I0
	jr
	ldx (I6)-1,C1 ; ldy (I6),I1
#else
// s_int16 FsMlcMapRead1(struct FsMapper *map, u_int32 sector,
// 		     u_int16 logicalBlocks, u_int16 *data) {

	.sect code,FsMlcMapRead1	// 89 words -> 67 words
	.export _FsMlcMapRead1
_FsMlcMapRead1:	// PROLOGUE
	ldx (I6)+1,NULL	// Room for Sp and Fp
	stx C1,(I6)+1 ; sty I1,(I6)
	stx LR0,(I6)+1 ; sty I0,(I6)	// return address
	stx I6,(I6) ; sty I4,(I6)
	ldx (I6)+1,I4	// FP' = SP, reserve space
	stx A1,(I6)+1 ; sty B0,(I6)
	stx B1,(I6) ; sty C0,(I6)

// 	register __c0 u_int16 eB = sector / ph->eraseBlockSize;

	ldc _ph,I1
	ldx (I1),I5	; ldy (I4)-5,NULL
	ldx (I4)+1,B0	; ldy (I5)+2,NULL	// sector
	and A1,NULL,A1	; ldx (I5),C1	//c1=eraseBlockSize
	call divide32unsigned
	add c1,null,a0	; ldx (I4)-1,B1

	ldc _fsMapTiny+FSMAPTINY_FIRSTBLOCK,I0
	add A0,NULL,C0	; ldx (I0),A0
	sub A0,C0,A1	; ldx (I6)+1,NULL
	ldc _fsMapTiny+FSMAPTINY_META,A0
	jzs L2	// ==
	nop

// 	if ((u_int16)fsMapTiny.firstBlock != eB) {
// 	    fsMapTiny.firstBlock = eB;
// 	    ph->Read(ph, fsMapTiny.root + (eB >> 8), 1, data, &fsMapTiny.meta);

	stx C0,(I0)+(FSMAPTINY_ROOT-FSMAPTINY_FIRSTBLOCK)
	stx A0,(I6)+1	; ldy (I4)-2,NULL
	ldc 256,A1
	muluu A1,C0	; ldx (I4),A0
	sub NULL,ONES,A0	; stx A0,(I6)+1
	add NULL,P,A	; stx A0,(I6)+1
	add a1,null,a0	; ldx (I0)+1,B0
	and A1,NULL,A1	; ldx (I0)-1,B1
	add B,A,B	; ldx (I1),I5
	stx B0,(I6)+1
	ldc 255,B0
	and C0,B0,B0	; ldx (I4)+2,A0
	add B0,A0,B0	; stx B1,(I6)+1
	stx I5,(I6)	; ldy (I5)+6,NULL
	ldx (I5),LR0	; ldy (I0)+(FSMAPTINY_LOGTOPHYS-FSMAPTINY_ROOT),NULL
	jr
	ldc $3,LR0
$3:

// 	    fsMapTiny.logToPhys = (u_int32)data[eB & 255] * ph->eraseBlockSize;

	mv B0,I5
	ldx (I5),A1
	muluu A1,C1
	add NULL,P,A
	stx A0,(I0)+1
	stx A1,(I0)-1	; ldy (I6)-5,NULL	//-6 and +1 combined

// 	}
//     }

L2:
//     {
// 	register __c u_int32 phy =
// 	    fsMapTiny.logToPhys + (sector & (ph->eraseBlockSize-1));
// 	ph->Read(ph, phy, 1, data, &fsMapTiny.meta);

	ldc _fsMapTiny+FSMAPTINY_LOGTOPHYS,I0
	ldx (I4)+1,A0	// sector
	and B1,NULL,B1	; ldx (I4)-3,A1
	add C1,ONES,B0	; ldx (I0)+1,C0
	and A,B,A	; ldx (I0)-1,C1
	ldc _fsMapTiny+FSMAPTINY_META,I5
	add C,A,C	; stx I5,(I6)+1
	ldx (I4)+7,A0	// data
	sub NULL,ONES,A0	; stx A0,(I6)+1
	stx A0,(I6)+1
	stx C0,(I6)+1
	stx C1,(I6)+1
	ldx (I1),I5
	stx I5,(I6)	; ldy (i5)+6,null
	ldx (I5),LR0
	jr
	ldc $4,LR0
$4:
//     }
//     return 1;

	sub NULL,ONES,A0	; ldx (I6)-6,NULL
	ldx (I6)-1,B1 ; ldy (I6),C0
	ldx (I6)-1,A1 ; ldy (I6),B0
	ldx (I4),I6 ; ldy (I4),I4	// Read Sp and Fp
	ldx (I6)-1,NULL
	ldx (I6)-1,LR0 ; ldy (I6),I0
	jr
	ldx (I6)-1,C1 ; ldy (I6),I1
#endif

	.end
