// extern struct FsMapperFlash fsMapFlash;
// extern struct FsMapperTiny fsMapTiny;
// s_int16 FsMlcMapRead(struct FsMapper *map, u_int32 sector,
// 		     u_int16 logicalBlocks, u_int16 *data) {


	.import _ph,_fsMapTiny,divide32unsigned

	.sect code,FsMlcMapRead	// 125 words -> 111 words
	.export _FsMlcMapRead
_FsMlcMapRead:
	ldx (I6)+1,NULL
	stx MR0,(I6)+1 ; sty I1,(I6)
	stx LR0,(I6)+1 ; sty I0,(I6)	// return address
	stx I6,(I6) ; sty I4,(I6)
	ldx (I6)+1,I4
	stx A1,(I6)+1 ; sty B0,(I6)
	stx B1,(I6)+1 ; sty C0,(I6)
	stx C1,(I6)+1 ; sty D0,(I6)
	stx D1,(I6)
	j LU1
	and NULL,NULL,C0	; ldx (i4)-6,null

//     register __c0 u_int16 bl = 0;
//     while (bl < logicalBlocks)

L1:
//  {
// 	if (sector < fsMapTiny.firstBlock || sector > fsMapTiny.lastBlock)

	ldy (I4)-5,NULL ; ldx (I0)+1,A1
	ldx (I4)+1,B0	// sector
	ldx (I4)+4,B1
	sub B,A,D
	ldc _ph,I1
	jcc L4	// <
	nop

	ldx (I0)+1,D0	// field lastBlock, offset 17
	ldx (I0)-1,D1
	sub D,B,A
	ldc _fsMapTiny+19,I0
	jcs L3	// >=
	nop

//  {
// 	    register __c1 u_int16 eB = sector / ph->eraseBlockSize;

	// indirect field eraseBlockSize, offset 2 (struct at page 1)
L4:
	ldx (I1),I7
	ldx (I7)+2,NULL
	call divide32unsigned
	and A1,NULL,A1	; ldx (I7),A0

	//ldc _ph,I1
	ldc 256,A1
	ldc _fsMapTiny+12,I0
	ldx (I6)+1,NULL ; add A0,NULL,C1

// 	    ph->Read(ph, fsMapTiny.root + (eB >> 8), 1, data, &fsMapTiny.meta);

	ldc _fsMapTiny+21,A0	// field meta, offset 21
	stx A0,(I6)+1 ; ldy (I4)-7,NULL
	muluu A1,C1	; ldx (I4)+7,A0	// data
	sub NULL,ONES,A0	; stx A0,(I6)+1
	and D1,NULL,D1	; stx A0,(I6)+1
	// field root, offset 12
	ldx (I0)+1,B0 ; add NULL,P,A
	mv A1,D0
	ldx (I0)-1,B1
	add B,D,B	; ldx (I1),I7
	stx B0,(I6)+1
	stx B1,(I6)+1
	stx I7,(I6)	; ldy (I7)+6,NULL
	ldx (I7),LR0	// indirect field Read, offset 6 (struct at page 1)
	jr
	ldc L5,LR0

L5:
// 	    fsMapTiny.logToPhys = (u_int32)data[eB & 255] * ph->eraseBlockSize;
// 	    fsMapTiny.firstBlock = sector & ~(u_int32)(ph->eraseBlockSize-1);
// 	    fsMapTiny.lastBlock = fsMapTiny.firstBlock + ph->eraseBlockSize-1;

	ldc 255,B1
	ldy (I4)-7,NULL ; ldx (I1),I7
	ldx (I4)+2,B0 ; ldy (I7)+2,NULL	// data
	and C1,B1,B1 ; ldx (I7),A0
	add B0,B1,B0 ; ldy (I0)+7,NULL	// #1 [] element size 1
	mv B0,I5 ; and B1,NULL,B1
	ldx (I5),A1 ; ldy (I6)-6,NULL
	// indirect field eraseBlockSize, offset 2 (struct at page 1)
	muluu A1,A0	// 16x16->32
	add NULL,P,A
	// field logToPhys, offset 19
	stx A0,(I0)+1
	stx A1,(I0)-5

	ldx (I4)+1,A0	// sector
	ldx (I4)+4,A1
	// indirect field eraseBlockSize, offset 2 (struct at page 1)
	ldx (I7),B0
	add B0,ONES,B0
	xor B,ONES,B
	and A,B,A
	// field firstBlock, offset 15
	stx A0,(I0)+1 ; and B1,NULL,B1
	stx A1,(I0)+1

	// indirect field eraseBlockSize, offset 2 (struct at page 1)
	ldx (I7),B0
	add A,B,A
	add A,ONES,A
	// field lastBlock, offset 17
	stx A0,(I0)+1
	stx A1,(I0)+1

// 	}
L3:

// 	{
// 	    register __b u_int32 phy = fsMapTiny.logToPhys + sector - fsMapTiny.firstBlock;
// 	    ph->Read(ph, phy, 1, data, &fsMapTiny.meta);

	// field logToPhys, offset 19
	//ldc _fsMapTiny+19,I0
	//ldc _ph,I1
	ldx (I0)+1,B0 ; ldy (I4)-5,NULL
	ldx (I0)-5,B1 ; ldy (I6)+1,NULL
	ldx (I4)+1,A0	// sector
	ldx (I4)-3,A1
	add B,A,B ; ldx (I0)+1,D0
	// field firstBlock, offset 15
	ldc _fsMapTiny+21,A0
	ldx (I0)-1,D1
	sub B,D,B ; stx A0,(I6)+1

	// field meta, offset 21
	ldx (I4)+2,A0	// data
	stx A0,(I6)+1 ; sub NULL,ONES,A0
	stx A0,(I6)+1
	stx B0,(I6)+1
	stx B1,(I6)+1
	ldx (I1),I7
	stx I7,(I6) ; ldy (I7)+6,NULL
	// indirect field Read, offset 6 (struct at page 1)
	ldx (I7),LR0
	jr
	ldc L6,LR0

L6:
// 	}
// 	sector++;
// 	data += 512/2;
// 	bl++;

	ldx (I4)+1,D0	; ldy (I6)-6,NULL	//i4:-5
	ldx (I4)-3,D1	//i4:-4
	sub D,ONES,D	; ldx (I4)+2,A0	//i4:-7 data
	stx D0,(I4)+1	//i4:-5
	ldc 256,A1
	add A0,A1,A1	; stx D1,(I4)-3	//i4:-4
	sub C0,ONES,C0	; stx A1,(I4)+1	//i4:-7 -> -6
LU1:
	ldx (I4)+6,A0	// logicalBlocks
	sub C0,A0,A1
	ldc _fsMapTiny+15,I0
	jcc L1	// <
	ldx (I0)+1,A0	// field firstBlock, offset 15

//     }
//     return bl;

	add C0,NULL,A0	; ldx (I6)-1,D1
	ldx (I6)-1,C1 ; ldy (I6),D0
	ldx (I6)-1,B1 ; ldy (I6),C0
	ldx (I6)-1,A1 ; ldy (I6),B0
	ldx (I4),I6 ; ldy (I4),I4	// Read Sp and Fp
	ldx (I6)-1,NULL
	ldx (I6)-1,LR0 ; ldy (I6),I0
	jr
	ldx (I6)-1,MR0 ; ldy (I6),I1

	.end
